
CoCoALib - Feature #1306

exgcd over integers (ZZ)

02 Sep 2019 16:08 - John Abbott

Status: In Progress Start date: 02 Sep 2019

Priority: Normal Due date:  

Assignee:  % Done: 20%

Category: New Function Estimated time: 0.00 hour

Target version: CoCoALib-0.99880 Spent time: 1.95 hour

Description

Implement a general extended gcd over the integers.

The idea is that the cofactors should be reasonably small.

Probable design:

L := [15,21,0,35];

exgcd(L);

record[gcd:=1, cofactors:=[1,1,0,-1]]

Name of record fields are "just a first guess".

Related issues:

Related to CoCoALib - Feature #1227: exgcd; solve Bezout equation New 19 Sep 2018

History

#1 - 02 Sep 2019 16:08 - John Abbott

- Related to Feature #1227: exgcd; solve Bezout equation added

#2 - 02 Sep 2019 16:12 - John Abbott

The cofactors are defined only modulo the lattice of "syzygies" (kernel of the row matrix); the hope is that the vector produced is a small one (not nec.

the smallest possible).

The function should not be too slow.

#3 - 02 Sep 2019 16:47 - Anna Maria Bigatti

Name extgcd?

I prefer with the 't'

#4 - 27 Feb 2020 21:05 - John Abbott

- Status changed from New to In Progress

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99800

- % Done changed from 0 to 20

I have a first (untested) prototype.  Maybe I'll test it tomorrow... too late now.

#5 - 28 Feb 2020 10:06 - John Abbott

Currently it returns just the cofacs.  I had hoped to avoid an include directive in the header file... not so easy.

The impl is correct, but tends to produce cofacs which are far too large (because I impl'ed a poor strategy).

Need to impl some better strategies!
#6 - 15 Apr 2021 11:34 - John Abbott

The source code is in NumTheory-gcd.C.

#7 - 28 Jan 2022 13:05 - John Abbott

- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99850

#8 - 08 Mar 2024 17:57 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99880
